<template>
  <div>
    <el-form ref="form" :model="form" :rules="rules" label-width="80px">
      <el-form-item label="真实姓名" prop="name">
        <el-input v-model="form.name" placeholder="请输入真实姓名" />
      </el-form-item>
      <el-form-item label="所在城市" prop="city">
        <el-input v-model="form.city" placeholder="请输入所在城市" />
      </el-form-item>
      <el-form-item label="身份证号码" prop="idNumber">
        <el-input v-model="form.idNumber" placeholder="请输入身份证号码" />
      </el-form-item>
      <el-form-item label="上传身份证正面" prop="filePath">
        <multi-upload
          v-if="allFileGetFlag"
          v-model="form.idCardFrontUrl"
          :serverAddr="materialServerAddr"
          fileName="身份证正面"
          :limit="1"
          @setImgPath="setUpPath"
        />
      </el-form-item>
      <el-form-item label="上传身份证反面" prop="filePath">
        <multi-upload
          v-if="allFileGetFlag"
          v-model="form.idCardBackUrl"
          :serverAddr="materialServerAddr"
          fileName="身份证反面"
          :limit="1"
          @setImgPath="setDownPath"
        />
      </el-form-item>
      <el-form-item label="测试能力" prop="testSkills">
        <el-input
          v-model="form.testSkills"
          type="textarea"
          placeholder="请输入内容"
        /><el-link type="primary">查看示例</el-link>
      </el-form-item>
      <el-form-item label="测试项目经历" prop="testProjects">
        <el-input
          v-model="form.testProjects"
          type="textarea"
          placeholder="请输入内容"
        /><el-link type="primary">查看示例</el-link>
      </el-form-item>
      <el-form-item label="奖项和证书" prop="certificate">
        <el-input
          v-model="form.certificate"
          type="textarea"
          placeholder="请输入内容"
        />
        <el-popover
          placement="top-start"
          title="示例："
          width="570"
          trigger="hover">
            <span>STQB认证软件测试工程师<br>国家软考认证软件评测师<br>或国家等级考试软件测试工程师证书 <br>
             2019年全国大学生软件测试大赛二等奖
            </span>
          <el-link slot="reference" style="color: #46a6ff;">查看示例</el-link>
        </el-popover>
      </el-form-item>
      <el-form-item label="工作经历" prop="workExperience">
        <el-input
          v-model="form.workExperience"
          type="textarea"
          placeholder="请输入内容"
        />
        <el-popover
          placement="top-start"
          title="示例："
          width="570"
          trigger="hover">
            <span>2017.5-2021.7 西安未央软件有限公司 软件测试工程师<br>
             2013.9-2017.4. 西安大唐软件有限公司 软件测试工程师<br>
             2009.9-2013.7 西安电子科技大学 软件工程专业 本科
            </span>
          <el-link slot="reference" style="color: #46a6ff;">查看示例</el-link>
        </el-popover>
      </el-form-item>
      <el-form-item label="上传其它补充材料" prop="filePath">
        <multi-upload
          v-if="allFileGetFlag"
          v-model="form.otherTQList"
          :serverAddr="materialServerAddr"
          fileName="其它补充材料"
          :limit="5"
          @setImgPath="setOtherPath"
        />
      </el-form-item>
    </el-form>
    <div slot="footer" class="dialog-footer">
      <el-button type="primary" @click="submitForm">确 定</el-button>
      <el-button @click="cancel">取 消</el-button>
    </div>
  </div>
</template>

<script>
import {
  listTesterApply,
  getTesterApplyByUid,
  delTesterApply,
  addTesterApply,
  updateTesterApply,
  exportTesterApply,
  getAllFileInfo,
} from "@/api/tester/TesterApply";
import MultiUpload from "@/views/components/MultiUpload";

export default {
  name: "TesterApply",
  components: {
    MultiUpload,
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 测试者认证申请表格数据
      TesterApplyList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        name: null,
        city: null,
        idNumber: null,
        testSkills: null,
        testProjects: null,
        workExperience: null,
        certificate: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
      materialServerAddr: "",
      allFileGetFlag: false,
    };
  },
  created() {
    this.getApplyByUserID(this.$route.query.userId);
  },
  methods: {
    /** 查询测试者认证申请列表 */
    getList() {
      this.loading = true;
      this.queryParams.params = {};
      if (null != this.daterangeAuditTime && "" != this.daterangeAuditTime) {
        this.queryParams.params["beginAuditTime"] = this.daterangeAuditTime[0];
        this.queryParams.params["endAuditTime"] = this.daterangeAuditTime[1];
      }
      if (null != this.daterangeCreateTime && "" != this.daterangeCreateTime) {
        this.queryParams.params["beginCreateTime"] =
          this.daterangeCreateTime[0];
        this.queryParams.params["endCreateTime"] = this.daterangeCreateTime[1];
      }
      if (null != this.daterangeUpdateTime && "" != this.daterangeUpdateTime) {
        this.queryParams.params["beginUpdateTime"] =
          this.daterangeUpdateTime[0];
        this.queryParams.params["endUpdateTime"] = this.daterangeUpdateTime[1];
      }
      listTesterApply(this.queryParams).then((response) => {
        this.TesterApplyList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        applyId: null,
        name: null,
        city: null,
        idNumber: null,
        testSkills: null,
        testProjects: null,
        workExperience: null,
        certificate: null,
        createTime: null,
        updateTime: null,
        idCardFrontUrl: [],
        idCardBackUrl: [],
        otherTQList: [],
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.daterangeAuditTime = [];
      this.daterangeCreateTime = [];
      this.daterangeUpdateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.applyId);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加测试者认证申请";
    },
    /** 加载审核页面数据操作 */
    getApplyByUserID(userId) {
      getTesterApplyByUid(userId).then((response) => {
        if (response.data) {
          this.form = response.data;
          getAllFileInfo(response.data.applyId).then((response) => {
            if (response.data) {
              // console.log(this.form.idCardFrontUrl);
              // console.log(response.data.idCardFrontUrl);
              if (response.data.idCardFrontUrl) {
                this.form.idCardFrontUrl = response.data.idCardFrontUrl;
              }

              // console.log(this.form.idCardFrontUrl);
              if (response.data.idCardBackUrl) {
                this.form.idCardBackUrl = response.data.idCardBackUrl;
              }
              if (response.data.otherTQList) {
                this.form.otherTQList = response.data.otherTQList;
              }
            }
            this.materialServerAddr = response.msAddr;
            this.allFileGetFlag = true;
          });
        } else {
          this.materialServerAddr = response.msAddr;
          this.allFileGetFlag = true;
        }
        this.open = true;
        this.title = "修改测试者认证申请";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          this.form.applyType = 0;
          if (this.form.applyId != null) {
            updateTesterApply(this.form).then((response) => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addTesterApply(this.form).then((response) => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const applyIds = row.applyId || this.ids;
      this.$confirm(
        '是否确认删除测试者认证申请编号为"' + applyIds + '"的数据项?',
        "警告",
        {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        }
      )
        .then(function () {
          return delTesterApply(applyIds);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        });
    },
    setUpPath(value) {
      // this.form.idCardFrontUrl = value;
    },
    setDownPath(value) {
      // this.form.idCardBackUrl = value;
    },
    setOtherPath(value) {
      // if(this.form.otherTQList == undefined){
      //   this.form.otherTQList = [];
      // }
      // // console.log(this.form.otherTQList);
      // this.form.otherTQList.push(value);
      // // console.log(this.form.otherTQList);
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有测试者认证申请数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return exportTesterApply(queryParams);
        })
        .then((response) => {
          this.download(response.msg);
        });
    },
  },
};
</script>
